library(ggplot2)

shinyServer(function(input,output){
   #output$pieChart <- renderPlot({print(main.mtd(rp.nm=input$recipe_name, rp.dir="recipe20140109teiban.data.csv", pd.dir="cultivated_area_teiban20140109.csv"))},height=850)
   output$pieChart <- renderPlot({print(main.mtd(rp.nm=input$recipe_name, rp.dir="recipe20140109teiban.data.csv", pd.dir="cultivated_area_teiban20140110.csv"))},height=450)
})

main.mtd <- function(rp.nm, rp.dir, pd.dir){

	rp.cnt <- get.rcp.const(rp.nm, rp.dir)

	all <- NULL
	for(i in 1:nrow(rp.cnt)){
		pd.cnt <- get.pd.rat(as.character(rp.cnt$material[i]), pd.dir)
		pd.cnt$vs.recipe.rat <- pd.cnt$yield.rat * rp.cnt$requirement.rat[i]
		all <- rbind(all, pd.cnt)
	}

	dbl.snt <- all$prefecture[duplicated(all$prefecture)]
	snt.vec <- unique(all$prefecture)
	allv <- NA
	for(j in 1:length(snt.vec)){
		sum.rat <- sum(all[all$prefecture==snt.vec[j],"vs.recipe.rat"])
		allv <- c(allv, sum.rat)
	}
	allv <- allv[-1]	
	
  out <- data.frame("prefecture"=as.character(snt.vec), "recipe.const.rat"=allv)

  # add to chose top 10 pref 2013.01.09 ishimura
	use.num <- 20
	ord.idx <- order(out$recipe.const.rat, decreasing=T)
	top3 <- out[ord.idx[1:use.num],]
	out <- rbind(top3, data.frame("prefecture"="その他", "recipe.const.rat"=sum(out$recipe.const.rat[na.omit(ord.idx[use.num+1:length(ord.idx)])])))
  
  g <- ggplot(out, aes(x="", y=recipe.const.rat, fill=prefecture)) + geom_bar(width=1) + coord_polar("y")
	g
}


get.rcp.const <- function(rp.nm, rp.dir){
	dat <- read.csv(rp.dir)
	
	z <- dat[dat$recipe==rp.nm, ]
	
	sum.rp <- sum(z[,"requirement"])
	z$requirement.rat <- z$requirement / sum.rp 
	
	out <- z[,c("material", "requirement.rat")]
	out
}

get.pd.rat <- function(pd.nm, pd.dir){
	dat <- read.csv(pd.dir)
	
	z <- dat[dat$material==pd.nm,]
	
	sum.pd <- sum(z[, "yield"], na.rm=T)
	
	z$yield.rat <- z$yield / sum.pd
	
	out <- z[, c("prefecture", "yield.rat")]
	out
}
